<?php
/*
  Copyright (C) 2006-2008 Vladislav Staroselskiy (inet@vladstar.com)
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/
  require "settings.php";
  require "functions.php";
  require "language.php";

  // Find out current absolute path and URI path
  $script_path=dirname($_SERVER["SCRIPT_FILENAME"])."/";
  $uri_path=dirname($_SERVER["REQUEST_URI"])."/";

  // Add trailing "/" to directories if not specified
  if (strrpos($picture_folder, "/")!=strlen($picture_folder)-1) { $picture_folder.="/"; }
  if (strrpos($thumbnail_folder, "/")!=strlen($thumbnail_folder)-1) { $thumbnail_folder.="/"; }
  if (strrpos($temp_folder, "/")!=strlen($temp_folder)-1) { $temp_folder.="/"; }
  if (! is_dir($script_path.$picture_folder)) {
    print MESSAGE_NO_PICTURE_FOLDER;
    exit;
  }
  $path=isset($_REQUEST["path"])?stripslashes(safe_path($_REQUEST["path"])):"";
  $file=isset($_REQUEST["file"])?basename(stripslashes(safe_path($_REQUEST["file"]))):"";
  $resize=isset($_REQUEST["resize"])?$_REQUEST["resize"]:"";
  $imageonly=isset($_REQUEST["imageonly"])?$_REQUEST["imageonly"]:"";
  $exif=isset($_REQUEST["exif"])?$_REQUEST["exif"]:"";
  $descr=isset($_REQUEST["descr"])?$_REQUEST["descr"]:"";
  if (isset($_REQUEST["res"]) && is_numeric($_REQUEST["res"]) && floor($_REQUEST["res"])<=$maximum_resolution && floor($_REQUEST["res"])>0) {
    $res=floor($_REQUEST["res"]);
  } elseif (isset($_REQUEST["res"]) && $_REQUEST["res"]=="0" && $resize) {
    $res=0;
  } else {
    $res=$default_resolution;
  }
  if ($_SERVER["REQUEST_METHOD"]=="POST" && ((isset($_SERVER["PHP_AUTH_USER"]) && array_search($_SERVER["PHP_AUTH_USER"],$allowed_users)!==false) || array_search($_SERVER["REMOTE_ADDR"],$allowed_ip)!==false) && $_POST["action"]==BUTTON_UPDATE && isset($_POST["descr"]) && isset($_POST["path"]) && isset($_POST["file"])) {
    if (is_dir($script_path.$picture_folder.$path) && is_writable($script_path.$picture_folder.$path)) {
      if (is_file($script_path.$picture_folder.$path.$file)) {
        update_descriptions($script_path.$picture_folder.$path.$description_file,$file,$_POST["descr"]);
      } elseif (is_dir($script_path.$picture_folder.$path.$file)) {
        update_descriptions($script_path.$picture_folder.$path.$folder_description_file,$file,$_POST["descr"]);
      }
    }
    header("location: ".$_SERVER["HTTP_REFERER"]);
  } elseif ($imageonly && $path && is_file($script_path.$picture_folder.$path)) {
    // Send resized image only, no any HTML code
    header("Content-Type: image/jpeg");
    header("Content-transfer-encoding: binary");
    create_JPEG_from_image($script_path.$picture_folder.$path,false,$res,false,$resized_image_quality,$less_restrictive,true);
    exit;
  }

  @include "html_top.inc";

  if ($path && is_dir($script_path.$picture_folder.$path)) {
    show_image($path,false,$res,$resize,$exif);
  } elseif ($path && is_file($script_path.$picture_folder.$path)) {
    show_image(dirname($path),basename($path),$res,$resize,$exif);
  } else {
    list_folders($descr);
  }

  if ($check_folders_structure && $numfolders=check_folders()) {
    print "<p class=\"message\">".MESSAGE_FOLDERS_DISREPANCY_1.$numfolders.MESSAGE_FOLDERS_DISREPANCY_2."</p>";
  }

  @include "html_bottom.inc";

  // Check temp folder and delete files if their TTL expired
  delete_expired_files($script_path.$temp_folder,$temp_files_TTL);

  exit;
?> 
